/*
	Yamashina Keisuke no SENGOKU
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			header_filename[13];
	char			out_filename[256];
	unsigned long	nowsize;

	int				i = 0;

	printf( "Yamashina Keisuke no SENGOKU File Divider 200913 (c)KUROHANE Works\n" );

	if( ac == 1 )
	{
		printf( "usage: SENGKDIV <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	printf( "\n" );

	buf = ( unsigned char * )calloc( 1, 0x1C );

	for( i = 0; i != 255; i++ )
	{
		fseek( in, i * 0x1C, SEEK_SET );
		fread( buf, 0x1C, 1, in );

		if( buf[0] == 0xFF ) continue;
		if( buf[0] == 0x00 ) break;

		header_filest = *( unsigned int *)( buf + 0x18 );
		header_filesize = *( unsigned int *)( buf + 0x14 ) - 1;
		header_fileed = header_filest + header_filesize;
		memcpy( header_filename, &buf[0], 12 );

		printf( "%04d : %s %04lX-%04lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 3 )
		{
			sprintf( out_filename, "%s%s",
				av[2],
				header_filename
			);
		} else sprintf( out_filename, "%s", header_filename );

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		fclose( out );
		printf( ".\n" );
		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
