/*
	Yamashina Keisuke no SENGOKU

	for LSI-C 86 ShishokuBan
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

char	*tmpname = "@@TMP@@.DAT";

unsigned long decodeLZ( FILE *in, unsigned long size, FILE *out )
{
	unsigned char	buf[256];
	unsigned char	*dic;
	unsigned long	dicpos = 0x0FEE;
	unsigned char	byte;
	unsigned char	sign;
	unsigned int	decode_startaddr;
	unsigned int	decode_length;
	int				i;
	int				q;
	unsigned long	decode_byte = 0L;
	unsigned long	read_byte = 0L;
	unsigned long	addr = 0L;

	dic = ( unsigned char * )calloc( 1, 4096 );

	while( read_byte < size )
	{
		/* compress sign */
		fread( buf, 1, 1, in ); sign = buf[0];
		read_byte++;

		for( i = 0; i != 8; i++ )
		{
			if( sign & 1 )
			{
				fread( buf, 1, 1, in ); byte = buf[0];
				dic[dicpos] = byte;
				fprintf( out, "%c", byte );
				dicpos++; dicpos &= 0x0FFF;
				read_byte++; decode_byte++;
			} else {
				fread( buf, 2, 1, in );
				decode_length = ( buf[1] & 0x0F ) + 3;
				decode_startaddr = ( buf[1] & 0xF0 ) << 4;
				decode_startaddr += buf[0];
				read_byte += 2;

				/* decode */
				for( q = 0; q != decode_length; q++ )
				{
					addr = decode_startaddr + q; addr &= 0x0FFF;
					dic[dicpos] = dic[addr];
					fprintf( out, "%c", dic[addr] );
					dicpos++; dicpos &= 0x0FFF;
					decode_byte++;
				}
			}
			sign >>= 1;
			if( read_byte > size ) break;
		}
	}
	free( dic );
	return decode_byte;
}

void main( int argc, char **argv )
{
	FILE			*in;
	FILE			*out;
	unsigned long	filesize_original = 0L;
	unsigned long	filesize_compress = 0L;

	printf( "Yamashina Keisuke no SENGOKU MUSIC Decompress tool 200914 (c)KUROHANE Works\n" );

	if( argc == 1 )
	{
		printf( "usage: SENGKEXT <filename>\n" );
		return;
	}

	in = fopen( argv[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", argv[1] );
		return;
	}

	printf( "filename: %s\n", argv[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	filesize_compress = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "filesize_compress: %lu\n", filesize_compress );

	out = fopen( tmpname, "wb+" );
	if( out == NULL )
	{
		printf( "error: can't write tempfile.\n" );
		goto end;
	}

	/* LZ Decode */
	filesize_original = decodeLZ( in, filesize_compress, out );
	fclose( out );

	printf( "filesize_original: %lu\n", filesize_original );

	remove( argv[1] );
	rename( tmpname, argv[1] );

	printf( "complete.\n" );

end:;
	fclose( in );
	return;
}
